#include <stdlib.h>
#include <libtk/wffcpp.h>
#include "io.h"


// FIXME:  this function has memory leaks, maybe
istream &
operator>>( istream &in, DArray<Polygon> &array )
{
    DArray<WfFace> a = WfFile::read( in );
    if( !a.length() )
    {
	cerr << "Cannot read file.\n";
	exit( 1 );
    }

    cout << "istream& operator>>(...):  Read " << a.length() << " polygons\n";
    for( int i=0; i<a.length(); i++ )
    {
	DArray<WfTriple> &v = a[i]->vertices();
	DArray<Vertex> verts;

	for( int j=0; j<v.length(); j++ )
	    verts.add( new Vertex(v[j]->tr) );

	array.add( new Polygon(verts,i+1) );
	verts.clear( 1 );
    }
    a.clear( 1 );
    return in;
}


// FIXME:  the following probably has memory leaks
ostream &
operator<<( ostream &out, DArray<Polygon> &a1 )
{
    DArray<WfFace> a2;

    for( int i=0; i<a1.length(); i++ )
    {
	DArray<WfTriple> v2;
	DArray<WfTriple> vn2;
	DArray<Vertex> &v1 = a1[i]->getVerts();

	for( int j=0; j<v1.length(); j++ )
	    v2.add( new WfTriple(v1[j]->v) );

	vn2.add( new WfTriple(a1[i]->normal().v) );
	a2.add( new WfFace(v2,vn2) );
    }
    WfFile::write( out, a2 );
    return out;
}


